<script lang="ts">
import Vue from 'vue';
import { AvailableLanguagesMixin } from '~/mixins';
import { CtfEntry, CtfTheSourceCategory } from '~/models';
import {
  getAvailableLanguagesFromTags,
  getUrlFromContentfulImage,
} from '~/common/util';
import TheSourceArticlesList from '~/components/the-source/articles-list.vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import TheSourceResources from '~/components/the-source/resources.vue';

export default Vue.extend({
  name: 'Index',
  components: { TheSourceResources, TheSourceArticlesList },
  mixins: [AvailableLanguagesMixin],
  layout: 'the-source',
  async middleware(context) {
    const slug = `the-source/${context.params.category}`;

    const page: CtfEntry<CtfTheSourceCategory> =
      await context.$theSourceService.getCategory(slug);

    context.$pageData = page;
    context.$availableLanguages = getAvailableLanguagesFromTags(
      page.metadata.tags,
    );
  },
  async asyncData({ $pageData, $theSourceService, $availableLanguages }) {
    const category: CtfTheSourceCategory = $pageData.fields;
    const categoryArticles = await $theSourceService.getArticlesByCategory(
      $pageData.sys.id,
    );
    const metadata = {
      title: category.title,
      description: category.description,
      image_title: getUrlFromContentfulImage(category.image),
    };

    return {
      category,
      categoryArticles,
      metadata,
      availableLanguages: $availableLanguages,
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      this.metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
      this.availableLanguages,
    );
  },
});
</script>

<template>
  <section class="ts-category">
    <div class="ts-category__hero">
      <SlpContainer>
        <SlpRow>
          <SlpColumn :cols="8" size="lg">
            <SlpTypography tag="h5" variant="all-caps" class="slp-mb-8"
              >{{ $t('articles.category') }}
            </SlpTypography>
            <SlpTypography tag="h1" variant="heading2-bold" class="slp-mb-24"
              >{{ category.title }}
            </SlpTypography>
            <SlpTypography tag="p" variant="body1" class="slp-mb-24"
              >{{ category.description }}
            </SlpTypography>
          </SlpColumn>
        </SlpRow>
      </SlpContainer>
    </div>
    <SlpContainer class="slp-pt-md-64 slp-pb-md-96">
      <SlpRow class="w-100">
        <SlpColumn
          :cols="category.gatedAssets?.length ? 8 : 12"
          size="lg"
          class="w-100"
        >
          <TheSourceArticlesList
            class="slp-pr-lg-16"
            :articles="categoryArticles"
            disable-category
          />
        </SlpColumn>
        <SlpColumn
          v-if="category.gatedAssets?.length"
          :cols="4"
          class="w-100 slp-mb-32"
          size="lg"
        >
          <TheSourceResources :resources="category.gatedAssets" surface-bg />
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.ts-category {
  &__hero {
    background-color: $color-surface-100;
    padding-top: $spacing-24;

    @media (width >= $breakpoint-md) {
      padding: $spacing-64 $spacing-24 $spacing-32 $spacing-24;
    }
  }
}
</style>
